/* globals.h:  global definitions
 * Copyright (C) 1987  Roger Hale
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * Changes made by  AC: Antonio Cau
 *                 BCM: Ben Moszkowski
 *
 * $Id: globals.h,v 2.13 2008/08/13 12:41:40 acau Exp $
 */

#include "fns.h"

extern unsigned Ready;
extern unsigned Retry;
extern unsigned NextFlag;
extern unsigned RedefFlag;
extern NODEPTR EmptyLoc;
extern unsigned Clock;
extern unsigned AlarmGone;


/* counter for top-level commands */
extern unsigned Counter;

/* Memory */
extern NODE GlobalMemory[];
extern unsigned LocalMemUsed;
extern NODEPTR TempLoc;
extern unsigned CurrBit;
extern unsigned NextBit;
extern unsigned OneLevelMemFlag;
extern unsigned TimeStampCheckFlag;

/* environment */
extern ENVSTACK EnvStack[];
extern int EnvTop;
extern int EnvBase;

/* reduce-stack */
extern REDUCESTACK ReduceStack[];
extern REDUCESTACKPTR ReduceStackTop;
extern REDUCESTACKPTR ReduceStackMax;
extern NODEPTR LastCommand;

/* tracing and debugging */
extern jmp_buf *BreakPoint;
extern int TempuraLevel;
extern int BreakDepth;
extern unsigned Break;
extern unsigned InterruptSet;
extern int PassLimitCounter;
extern unsigned PassProgressFlag;
extern unsigned StateProgressFlag;
extern unsigned ForceOutput;
extern unsigned RunFlag;
extern int SyntaxErrorCount;

/* statistics */
extern unsigned StateNumber;
extern unsigned PassNumber;
extern unsigned TotalPassCount;
extern unsigned TotalReduceCount;
extern unsigned TotalReduceTimes;
extern unsigned StateReduceCount;
extern unsigned PassReduceCount;
extern unsigned TotalSuccessfulReduceCount;
extern unsigned TotalSuccessfulReduceTimes;
extern unsigned StateSuccessfulReduceCount;
extern unsigned PassSuccessfulReduceCount;
extern int ReduceDepth;
extern int MaxReduceDepth;

/* Static values (very commonly used) */
extern NODEPTR True, False;
extern NODEPTR Zero, One;
extern NODEPTR Nil, Empty, More, Skip, Ranlen, Infinite, Random, RRandom;
extern NODEPTR EndOfFile;

/* Heap */
extern HEAP Heap;
extern unsigned HeapSize;
extern unsigned FreeNodes;
extern NODEPTR FreeNodeList;
extern NODEPTR TempNodeList;

/* Symbol Table */
extern NODEPTR SymbolTableTop;
extern NODEPTR SymbolTableMax;
extern NODEPTR HashTable[];

/* Wait list for system calls */
extern NODEPTR SysWaitList;

/* System variables (user definable). */
extern int PassLimit;
extern int Verbosity;
extern int PrintLevel;
extern int DebugLevel;
extern unsigned StatePrintFlag;
extern unsigned RedundancyFlag;
extern unsigned CallByNameFlag;
extern unsigned AssignAheadFlag;
extern unsigned HopChop;

/* To fix the path problem:
   extern char *Path;
   extern char *HelpDir;
*/
extern NODEPTR Path;
extern NODEPTR HelpDir;
extern NODEPTR InFile;
extern NODEPTR OldInFile;
extern NODEPTR OutFile;
extern FILE *Fpcur;



extern int TimeStep;
/* AC 29Apr1999 */
extern int RandSeed;
extern int MaxRandLen;
extern int RandomVal;
extern unsigned RandomValTime;
/* AC 20/09/2000 */
extern int RRandSeed;
extern int RRandomVal;
extern unsigned RRandomValTime;

/* Input/Output */
extern NODEPTR AuxVal;
extern int CharsOutput;
extern int InputLineCount;
extern FILE *InputFile;
extern char InputText[];
extern char *InputFilename;

/* Parser */
extern unsigned Token;
extern unsigned Recover;
extern char *Keyword[];

/* Reduction functions */

extern PFI Reduces[MAXREDUCETOKEN + 1][3];
/*extern PFI ReduceStmt[];
extern PFI ReduceVal[];
extern PFI ReduceRef[];
*/
